<?php
ini_set('display_errors', 1);

require_once '../../../resources/base_path_include.php';

//valdation file
require_once $base_path_to_resources . "includes/config.php"; // use require for mandatory files
require_once $base_path_to_resources . 'lib/function.php';
require_once $base_path_to_resources . "lib/currency_functions.php";
require_once $base_path_to_resources . 'lib/validate_api_signature.php';
require_once $base_path_to_resources . 'lib/validate_function.php';
require_once $base_path . 'user_management/authenticate.php';
require_once $base_path_to_resources . 'includes/specific_db_config.php';


//valdation file
require_once $base_path . 'modules/accounting/book_management/basic_book_info_function.php';
require_once $base_path . 'modules/accounting/stock_management/functions/functions.php';
require_once $base_path . 'modules/accounting/stock_management/inventory_regions/region_functions.php';
require_once $base_path . 'modules/accounting/book_management/basic_book_info_function.php';
require_once $base_path . 'modules/accounting/reports/valuation_methods/closing_stock_summary/fifo_summary_function.php';

//excel and pdf files
// require_once $base_path . 'modules/accounting/groups_ledgers/export/pdf/ledger_pdf_functions.php';


$postdata = json_decode(file_get_contents("php://input"), true);
checkIfNoPhpContentsReceive();

if ( !isset($postdata['company_id']) or !checkIfIssetAndNotEmpty($postdata['company_id']) or  !isset($postdata['branch_id']) or !checkIfIssetAndNotEmpty($postdata['branch_id']) or
!isset($postdata['book_id']) or !checkIfIssetAndNotEmpty($postdata['book_id'])  or  !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
!isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type']) or !isset($postdata['jwt_token']) or !checkIfIssetAndNotEmpty($postdata['jwt_token'])) {
    errorreturn("All fields are required.");
}

validateApiSignature($postdata['api_signature']);
//authenticate jwt token
$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
//then workspace_id is decoded in data of jwt use from there
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$role = $jwt_validate->data->role;
$username = $jwt_validate->data->username;


if ($postdata['function_type']  == "fetch_batch_details") {


    if (isset($postdata['search_string']) and !empty($postdata['search_string'])) {
        $search_string = trim($postdata['search_string']);
    } else {
        $search_string = null;
    }
    
    if (isset($postdata['type']) and !empty($postdata['type']) and in_array(trim($postdata['type']), ['all', 'sales', 'opening', 'purchase'])) {
        $type = trim($postdata['type']);
    } else {
        $type = "all";
    }
  

    $company_id = trim($postdata['company_id']);
    $branch_id = trim($postdata['branch_id']);
    $book_id = trim($postdata['book_id']);
    $stock_id = trim($postdata['stock_id']);
    $function_code = $postdata['function_type'];
    
    $confirmed_role_user = validatePrimaryAccess($conn, $workspace_id, $role, $userid, ['superadmin', 'admin', null]);
    if (!$confirmed_role_user){ 
        errorreturn('Access denied.');
    }else{
        $specific_db_conn = dynamicDbConnection($confirmed_role_user);
        //  if ($role == null) {
        //     checkCompanyBranchFunctionAccess($specific_db_conn, $role, $userid, $workspace_id, $company_id, $branch_id, $book_id,  $function_code);
        //  }
    }
    
     $book_info = GetBasicBook($specific_db_conn, $workspace_id, $company_id, $branch_id, $book_id);
    // print_r($book_info);
    $book_name = $book_info['book_basic_info']['book_name'];
    $book_opening_date = $book_info['book_basic_info']['book_opening_date'];
    $book_closing_date = $book_info['book_basic_info']['book_closing_date'];
    
    if (isset($postdata['mindate']) and !empty($postdata['mindate'])) {
        $mindate = trim($postdata['mindate']);
    } else {
        $mindate = $book_opening_date;
    }
    if (isset($postdata['maxdate']) and !empty($postdata['maxdate'])) {
        $maxdate = trim($postdata['maxdate']);
    } else {
        $maxdate = $book_closing_date;
    }
    if (!strtotime($mindate) or $mindate < $book_opening_date) {
        errorreturn('Mininum date cannot be less than book opening date');
    }
    if (!strtotime($maxdate) or $maxdate > $book_closing_date) {

        errorreturn('Maximum date cannot be less than book opening date');
    }
    if ($maxdate < $mindate) {

        errorreturn('Invalid Date format');
    }

   
    $page = (isset($postdata['page']) and isNumeric($postdata['page'])) ? (int)$postdata['page'] : 1;

      $limit = $postdata['limit'];

    if ($limit != 'all') {
        $offset = ($page - 1) * $limit;
    } else {
        $offset = null;
    }

    $export_type = (isset($postdata['export_type']) and !empty($postdata['export_type'])) ? trim($postdata['export_type']) : null;

        if ($limit != 'all') {
            $offset = ($page - 1) * $limit;
            $success['data'] = GetBatchDetail($specific_db_conn, $workspace_id, $company_id, $branch_id, $book_id,$stock_id, $search_string,$type,$mindate, $maxdate, $limit, $offset);
            successreturn($success);
        } else {

            $success['data'] = GetBatchDetail($specific_db_conn, $workspace_id, $company_id, $branch_id, $book_id,$stock_id, $search_string,$type, $mindate, $maxdate,$limit, null);
            successreturn($success);
        }
    
}
